package com.fr.plugin.platform.db.transfer.dm;

import com.fr.data.core.db.dialect.DmDialect;
import com.fr.data.core.db.dialect.base.DialectKeyConstants;
import com.fr.data.core.db.dialect.base.key.check.schema.DialectHasSchemaExecutor;
import com.fr.data.core.db.dialect.base.key.hibernate.HibernateDialectClassExecutor;
import com.fr.data.core.db.dialect.base.key.schema.PhoenixDialectSchemaExecutor;
import com.fr.data.core.db.dialect.base.key.validationquery.SELECT1DialectDefaultValidationQueryExecutor;

public class DMDialect extends DmDialect {

    public DMDialect() {
        super();
        putExecutor(DialectKeyConstants.HIBERNATE_DIALECT_CLASS_KEY, new HibernateDialectClassExecutor(FRDMDialect.class.getName()));
        putExecutor(DialectKeyConstants.CHECK_HAS_SCHEMA_KEY, new DialectHasSchemaExecutor());
        putExecutor(DialectKeyConstants.SCHEMA_KEY, new PhoenixDialectSchemaExecutor());
        putExecutor(DialectKeyConstants.DEFAULT_VALIDATION_QUERY_KEY, new SELECT1DialectDefaultValidationQueryExecutor());
    }
}
