package com.fr.plugin.platform.db.transfer.dm;

import com.fr.plugin.transform.ExecuteFunctionRecord;
import com.fr.plugin.transform.FunctionRecorder;
import com.fr.stable.UrlDriver;
import com.fr.stable.fun.impl.AbstractDialectCreator;

import java.sql.Connection;
import java.sql.DatabaseMetaData;

@FunctionRecorder
public class DMDialectCreator extends AbstractDialectCreator {

    public final static String Driver = "dm.jdbc.driver.DmDriver";
    public final static String DBName = "DM DBMS";

    @ExecuteFunctionRecord
    @Override
    public Class<?> generate(UrlDriver urlDriver) {
        if (null == urlDriver) {
            return null;
        }
        // "dm.jdbc.driver.DmDriver"
        if (Driver.equals(urlDriver.getDriver().trim())) {
            return DMDialect.class;
        }
        return null;
    }

    @Override
    public Class<?> generate(Connection connection) {
        try {
            DatabaseMetaData databaseMetaData = connection.getMetaData();
            String databaseName = databaseMetaData.getDatabaseProductName();
            //"DM DBMS"
            if (DBName.equals(databaseName)) {
                return DMDialect.class;
            }
        } catch (Exception e) {

        }
        return null;
    }
}
