package com.fr.plugin.platform.db.transfer.dm.interceptor;

import com.fr.log.FineLoggerFactory;
import com.fr.log.FineLoggerProvider;
import com.fr.stable.db.extra.DBCreationHook;
import com.fr.stable.db.extra.interceptor.impl.EmptyStringConvertInterceptor;
import com.fr.stable.db.option.DBCreationOption;
import com.fr.third.org.hibernate.cfg.Configuration;

import java.util.Properties;

/**
 * @Author JianYe.Wang
 * @Data 2021/7/2 13:47
 * @Description 达梦数据库 COMPATIBLE 参数为 2 的情况
 * @Version 10.0
 **/
public class DBInterceptorCreationHook implements DBCreationHook {
    public DBInterceptorCreationHook() {
    }

    public void onCreateSessionFactory(DBCreationOption option, Configuration configuration) {
        Properties properties = configuration.getProperties();
        if (isDM(properties)) {
            option.addInterceptor(EmptyStringConvertInterceptor.INSTANCE);
        }
    }

    private boolean isDM(Properties properties) {
        String driver = properties.getProperty("hibernate.connection.driver_class");
        FineLoggerFactory.getLogger().info("DBInterceptorCreationHook properties :{} driver :{}", properties, driver);
        return driver != null && driver.toLowerCase().contains("dm.jdbc");
    }
}
